<?php
defined('is_running') or die('Not an entry point...');

gpPlugin::Incl('COMMON.php');

class rifBBCloneAdmin extends rifBBCloneCommon{

	static function admn_menu() {
		global $addonPathData;
		global $langmessage, $addon_current_id;
		$translinks = $langmessage[$addon_current_id]["--ADMIN_LINKS--"];
		
		$moreinfo = '<a style="margin-top:3px;padding-right:5px;float:right;font-weight:normal;font-style:italic;" target="_blank" href="'.$translinks["--MoreInfoLink--"].'"> | '.$langmessage[$addon_current_id]['More Info for plugin'].'... </a> ';
		
		$links = '<div style="font-weight:bold;font-size:16px;border-bottom:1px solid #dddddd;margin-bottom:20px;padding-bottom:5px;">';		
		$links .= common::Link('Admin_BBC_Global_Stats',$translinks["Admin_Link:Admin_BBC_Global_Stats"])." | ";
		$links .= common::Link('Admin_BBC_Detailed_Stats',$translinks["Admin_Link:Admin_BBC_Detailed_Stats"])." | ";
		$links .= common::Link('Admin_BBC_Time_Stats',$translinks["Admin_Link:Admin_BBC_Time_Stats"])." | ";
		//$links .= common::Link('Admin_BBC_Show_Views',$translinks["Admin_Link:Admin_BBC_Show_Views"])." | ";
		$links .= common::Link('Admin_BBC_Configuration',$translinks["Admin_Link:Admin_BBC_Configuration"])." | ";
		$links .= $moreinfo;		
		$links .= '</div>';
		
		return $links;

	}
	
	static function get_config() {
		global $page, $addonPathCode, $addonRelativeCode, $addonPathData;
		
		require_once($addonPathCode."/constants.php");
		self::ConstantGlobals();
		
		if(!file_exists($BBC_CONFIG_FILE)){
			@mkdir($BBC_CONF_PATH);
			copy($addonPathCode."/conf/config.php", $BBC_CONFIG_FILE);
		}
		
		if(!file_exists($BBC_CACHE_PATH)){
			$dir = opendir($addonPathCode."/var"); 
			@mkdir($BBC_CACHE_PATH); 
			while(false !== ($file = readdir($dir))) { 
				if (( $file != '.' ) && ( $file != '..' )) { 
					copy($addonPathCode.'/var/'.$file, $BBC_CACHE_PATH.$file); 
				} 
			} 
			closedir($dir); 
		}
		
		$page->css_user[] = $addonRelativeCode.'/css/bbclone.css';
		
		self::ConfigGlobals();
		
		require_once($BBC_LIB_PATH."html.php");
		require_once($BBC_LIB_PATH."selectlang.php");
		
	}
}


class ShowGlobals extends rifBBCloneAdmin{
	
	public function __construct() {
		global $addonPathCode;
		global $langmessage, $addon_current_id;
		global $BBC_ACCESS_FILE;
		
		$translation = $langmessage[$addon_current_id]["translation"];
		
		echo self::admn_menu();
		
		if(!defined("_BBC_PAGE_NAME")){define("_BBC_PAGE_NAME", "BBClone - Show Global");}
		$start =self::start_time();
		
		self::get_config();
		require_once($BBC_ACCESS_FILE);
		
		$BBC_HTML = new BBC_HTML;

		include_once("show_global.php");		
		self::end_time($start);
	}
	
}


class ShowViews extends rifBBCloneAdmin{
	
	public function __construct() {
		global $addonPathCode;
		global $langmessage, $addon_current_id;
		global $BBC_LAST_FILE;
		
		$translation = $langmessage[$addon_current_id]["translation"];
				
		echo self::admn_menu();
		
		if(!defined("_BBC_PAGE_NAME")){define("_BBC_PAGE_NAME", "BBClone - Show Views");}
		$start =self::start_time();
		
		self::get_config();
		require_once($BBC_LAST_FILE);
		
		$BBC_HTML = new BBC_HTML;
		
		include_once("show_views.php");		
		self::end_time($start);
	}
	
}


class ShowTime extends rifBBCloneAdmin{	

	public function __construct() {
		global $addonPathCode;
		global $langmessage, $addon_current_id;
		global $BBC_ACCESS_FILE;
		
		$translation = $langmessage[$addon_current_id]["translation"];
				
		echo self::admn_menu();
		
		if(!defined("_BBC_PAGE_NAME")){define("_BBC_PAGE_NAME", "BBClone - Show Time");}
		$start =self::start_time();
		
		self::get_config();		
		require_once($BBC_ACCESS_FILE);
		
		$BBC_HTML = new BBC_HTML;
		
		include_once("show_time.php");		
		self::end_time($start);
	}
	
}


class ShowDetailed extends rifBBCloneAdmin{	

	public function __construct() {
		global $addonPathCode;
		global $langmessage, $addon_current_id;
		global $BBC_LAST_FILE;
		
		$translation = $langmessage[$addon_current_id]["translation"];
	
		echo self::admn_menu();

		if(!defined("_BBC_PAGE_NAME")){define("_BBC_PAGE_NAME", "BBClone - Show Detailed");}
		$start =self::start_time();
		
		self::get_config();
		require_once($BBC_LAST_FILE);
		
		$BBC_HTML = new BBC_HTML;
	
		include_once("show_detailed.php");		
		self::end_time($start);
	}
	
}


class ShowConfig extends rifBBCloneAdmin{
	
	public function __construct() {
		global $addonPathCode, $addonPathData;
		global $langmessage, $addon_current_id;
		global $BBC_ACCESS_FILE;
		
		$translation = $langmessage[$addon_current_id]["translation"];
		
		$start = self::start_time();
		
		$DefaultConf = gpFiles::Get( $addonPathCode.'/conf/config.php', 'bbc_config');
		$config = gpFiles::Get( $addonPathData.'/config.php', 'bbc_config');
		$killstats = false;	
		
		if(isset($_POST['cmd']) && $_POST['cmd'] == 'bbc_saveconfig'){
			
			//EREASE ALL STATS		
			if(isset($_POST['config']['BBC_KILL_STATS'])){
				$killstats = true;
			}
			//
			
			foreach($DefaultConf as $key => $val ){
				
				if(!isset($_POST['config'][$key])){
					$_POST['config'][$key] = "";
				}

				$config[$key] = $_POST['config'][$key];
		
				if(trim($config[$key]) == "" && $key != 'BBC_IGNORE_BOTS'){					
					$config[$key] = $val;
				}
					
			}
			
			if( gpFiles::SaveArray($addonPathData.'/config.php', 'bbc_config', $config)){
				message($langmessage["SAVED"]);
			}else
				message("Error");
		}

		self::get_config();
		
		echo self::admn_menu();				
		
		if(!defined("_BBC_PAGE_NAME")){define("_BBC_PAGE_NAME", "BBClone - Show Config");}	
		
		//EREASE ALL STATS
		if($killstats){
			global $BBC_LIB_PATH, $BBC_KILL_STATS, $BBC_CACHE_PATH, $BBC_ACCESS_FILE, $BBC_LAST_FILE, $BBC_DEBUG, $BBC_LOCK;
			
			if (!defined("_MARK_PAGE")) 
				define("_MARK_PAGE", "1");
	
			require_once($BBC_LIB_PATH."io.php");
			require_once($BBC_LIB_PATH."marker.php");
			
			$BBC_KILL_STATS = 1;
			$BBC_DEBUG = "";
			include($addonPathCode."/mark_page.php");
			
			file_put_contents($BBC_ACCESS_FILE, "<?php\nglobal \$access;\n\$access =\n array();\n?>");
			file_put_contents($BBC_LAST_FILE, "<?php\nglobal \$last;\n\$last =\n array();\n?>");
		}
		//		

		require_once($BBC_ACCESS_FILE);
		
		$BBC_HTML = new BBC_HTML;
		
		include_once("show_config.php");
		
		self::end_time($start);		
	}
	
}

