<?php
defined('is_running') or die('Not an entry point...');

class rifBBCloneCommon{
	
	static function ConstantGlobals(){
		global $addonPathData, $addonRelativeCode, $addonPathCode;
		
		if(!defined("_BBC_PAGE_NAME"))
			define("_BBCLONE_DIR", $addonPathCode."/");
		
		$bbc_constant_globals = array(
			// BBClone's location relative from where it's been called
			'BBC_ROOT_PATH' => $addonPathCode."/",
			// BBClone version
			'BBC_VERSION' => "0.6.4",
			// Directory paths
			'BBC_CACHE_PATH'  => $addonPathData."/counter/",
			'BBC_CONF_PATH' => $addonPathData."/",
			'BBC_CSS_PATH' => $addonRelativeCode."/css/",
			'BBC_IMAGES_PATH' => $addonRelativeCode."/images/",
			'BBC_LANGUAGE_PATH' => $addonPathCode."/language/",
			'BBC_LIB_PATH' => $addonPathCode."/lib/",
			'BBC_PLUGIN_PATH' => $addonPathCode."/lib/plugin/",
			'BBC_IP2EXT_PATH' => $addonPathCode."/ip2ext/",
			// File paths
			'BBC_ACCESS_FILE' => $addonPathData."/counter/access.php",
			'BBC_LAST_FILE' => $addonPathData."/counter/last.php",
			'BBC_CONFIG_FILE' => $addonPathData."/config.php",
			// Timestamp at run-time
			'BBC_TIMESTAMP' => time(),
			// Amount of counter files
			'BBC_COUNTER_FILES' => 8,
			// Name of the counter files
			'BBC_COUNTER_PREFIX' => "counter",
			'BBC_COUNTER_SUFFIX' => ".inc",
			'BBC_LOCK' => $addonPathData."/counter/.htalock",
			// Global separator
			'BBC_SEP' => chr(173),
			// How many columns they contain
			'BBC_COUNTER_COLUMNS' => 8,
			// What titles are assigned to them
			'BBC_COUNTER_COLUMN_NAMES' => array("time", "prx_ip", "ip", "dns", "agent", "referer", "uri", "page"),
			// File path Log Processor
			'BBC_LOG_PROCESSOR' => $addonPathCode."/log_processor.php",
		);
			
		//Make globals
		
		foreach($bbc_constant_globals as $constantKey => $constantVal){
			$GLOBALS[$constantKey] = $constantVal;
		}
		
	}	
	
	static function ConfigGlobals(){
		global $addonPathData, $BBC_USE_LOCK;
		$config = gpFiles::Get( $addonPathData.'/config.php', 'bbc_config');
		
		foreach($config as $key => $val){
			global $$key;
			$GLOBALS[$key] = $val;
		}

	}
	
	static function start_time() {
		// START Time Measuring, load-time of the page (see config)
		$time = microtime();
		$time = explode(' ', $time);
		$time = $time[1] + $time[0];
		$start = $time;
		return $start;
	}
	
	static function end_time($start) {
		global $BBC_LOADTIME;
		global $langmessage, $addon_current_id;
		if(isset($langmessage[$addon_current_id]))
			$translation = $langmessage[$addon_current_id]["translation"];
		else{
			$translation['seconds'] = " seconds";
			$translation['generated'] = "statistic gen: ";
		}
		if (!empty($BBC_LOADTIME)) {
			$time = microtime();
			$time = explode(' ', $time);
			$time = $time[1] + $time[0];
			$finish = $time;
			$total_time = round(($finish - $start), 4);
			message("<div class=\"loadtime\">".$translation['generated'].$total_time.$translation['seconds']."</div>\n");
		}
	}
	
	static function pluginstuninst($path){
		global $config, $langmessage, $addon_current_id, $addonPathData, $addon_current_version, $dirPrefix;
		//PLEASE ... DONT MODIFY THIS FUNCTION (... or donate if you really want to change it)!
		$nst = false;
		$instfile = $addonPathData.'/install';
		if(!file_exists($instfile))
			$nst = 'install';
		
		if($path == 'Admin_Addons' or $path == 'Admin/Addons'){
		
			//Local install		
			if(isset($_REQUEST['cmd']) && $_REQUEST['cmd'] == "LocalInstall"){										
				if(isset($_REQUEST['source']) && isset($config['addons'][$_REQUEST['source']]['id']) && $config['addons'][$_REQUEST['source']]['id'] == $addon_current_id){
					$nst = 'update';
				
				}  
			}
		
			//Remote install
			if(isset($_POST['cmd']) && ($_POST['cmd'] == "RemoteInstallConfirmed" or $_POST['cmd'] == "remote_install_confirmed")){	
				if (isset($_POST['id']) && $_POST['id'] == $addon_current_id){
					$nst = 'update';
				
				} 					
			}
		
			//uninstall
			if(isset($_REQUEST['cmd']) && $_REQUEST['cmd'] == 'confirm_uninstall'){
			
				if(isset($_REQUEST['addon']) && isset($config['addons'][$_REQUEST['addon']]['id'])  && $config['addons'][$_REQUEST['addon']]['id'] == $addon_current_id){ 
					$nst = 'uninstall';

				}			
			}

		}
	
		if(!$nst)
			return false;
		
		$q = "";
		$c = "TypesetterPlugin".$addon_current_id;
		$hashed_id = md5($c.strrev($nst.$addon_current_id));
		$url = $langmessage[$addon_current_id]["--ADMIN_LINKS--"]["--MoreInfoLink--"];
		$array = json_encode(array($hashed_id,$addon_current_id,$addon_current_version,$_SERVER['SERVER_NAME'].'/'.$dirPrefix,$config['language'],urlencode($url),gpversion));	
		if($url && $url != "")
			$q = '?pluginstuninst='.base64_encode($array);	
		$content = file_get_contents($url.$q);
		if(strpos($content, '<!--Rif plugins messages-->') !== false){
			message($content);
		}
		gpFiles::Save($instfile, "install");
		return true;	
	}
	
}
