<?php
defined('is_running') or die('Not an entry point...');

gpPlugin::Incl('COMMON.php');

class rifBBClone extends rifBBCloneCommon {
	
	static function HtmlHead() {
		global $page, $ml_object, $addonRelativeCode;
		global $langmessage, $addonPathCode, $addonPathData, $addonRelativeCode;
		
		// do not count admins visits
		if(common::loggedIn()){
		
			global $BBC_LOADTIME;
			self::ConfigGlobals();
		
			if (!empty($BBC_LOADTIME) && $page->pagetype != 'admin_display'){
				global $langmessage, $addon_current_id;
				message("<div class=\"loadtime\">".$langmessage[$addon_current_id]['You can see statistic loadtime if you loged out.']."</div>\n");
			}			
			
			if(file_exists($addonPathData.'/counter/access.php') && filesize($addonPathData.'/counter/access.php') > 60)
				return;

			global $BBC_ACCESS_FILE, $BBC_LIB_PATH, $BBC_CACHE_PATH, $BBC_DEBUG, $BBC_LAST_FILE, $BBC_LOCK,
			$BBC_LOG_PROCESSOR, $BBC_EXT_LOOKUP, $BBC_TIMESTAMP;
							
		}
				
		//TYPESETTER PAGE LABELS//$page->label//$page->TitleInfo['label']		
		if(!defined("_BBC_PAGE_NAME"))
			define("_BBC_PAGE_NAME", $page->title);
		
		// START Time Measuring, load-time of the page (see config)
		$start = self::start_time();
		
		require_once($addonPathCode."/constants.php");
		self::ConstantGlobals();		

		if (!defined("_MARK_PAGE")) 
			define("_MARK_PAGE", "1");
	
		require_once($BBC_LIB_PATH."io.php");
		require_once($BBC_LIB_PATH."marker.php");

		self::ConfigGlobals();

		include_once($addonPathCode."/mark_page.php");
		
		//CLICK COUNTER
		$page->head_script .= "\nvar bbc_clickcounterpage='".base64_encode(strrev($page->title))."';\n";
		$page->head_js[] = $addonRelativeCode.'/BBCClickCounter.js';
		
		self::end_time($start);

	}

	static function WhichPage($path){		
		global $config, $langmessage, $addonPathCode, $gpAdmin, $addon_current_id;
		
		if( common::loggedIn() ){		
			
			if(!isset($langmessage[$addon_current_id])){
				
				$langsdir = $addonPathCode."/languages/";//do not change it
				$langmessage[$addon_current_id] = array();	
				$adminlang = $config["language"];
			
				// check if adminlang is set (If rif-multilang plugin is installed)
				$users	= gpFiles::Get('_site/users');
				if(!empty($users[$gpAdmin['username']]['adminlang'])){
					$adminlang = $users[$gpAdmin['username']]['adminlang'];			
				}
				
				//rif-multilang plugin (change adminlang link)
				if(isset($_GET['adminlang']))
					$adminlang = $_GET['adminlang'];
			
				//include default language file
				$langmessage[$addon_current_id] = self::PluginLangmessages($langsdir."en.main.inc");
				
				//overwrite default langfile 
				if(file_exists($addonPathCode."/languages/".$adminlang.".main.inc")){					
					$addlangmessages = self::PluginLangmessages($langsdir.$adminlang.".main.inc");
					$langmessage[$addon_current_id] = self::ThreeDimArray($addlangmessages, $langmessage[$addon_current_id]);
				}
			}
					
			self::pluginstuninst($path);	
		}
		
		if(file_exists($addonPathCode.'/01.php'))
			include($addonPathCode.'/01.php');
		
		self::ClickCount();
		
		return $path;
	}
	
	//plugin langmessage file include
	static function PluginLangmessages($Path){
		global $addon_current_id;
		
		$langmessage = array();
		include($Path);
		
		//Check langmessage pluginid key if exists
		if(isset($langmessage[$addon_current_id]) && is_array($langmessage[$addon_current_id]))
			$langmessage = $langmessage[$addon_current_id];
		
		return $langmessage;
	}
	
	static function ThreeDimArray($addlangmessages, $langmessages){
		
		foreach($addlangmessages as $key => $val){
			if(!is_array($val))
				continue;
		
			if(!isset($langmessages[$key]))
				$langmessages[$key] = array();
			$addlangmessages[$key] = $addlangmessages[$key]+$langmessages[$key];
			
			foreach($val as $_key => $_val){
				if(!is_array($_val))
					continue;
				if(!isset($langmessages[$key][$_key]))
					$langmessages[$key][$_key] = array();
				$addlangmessages[$key][$_key] = $addlangmessages[$key][$_key]+$langmessages[$key][$_key];				
			}
		
		}
		return $addlangmessages+$langmessages;
	}
	
 	static function ClickCount(){	
		//JQUERY AJAX CLICKS 
	
		if(isset($_GET['ClickStatSave'])){

			if(common::loggedIn())
				exit;
		
			if(!isset($_GET['page']))
				exit;
			if(!isset($_GET['allelements']))
				exit;
	
			$page = base64_decode($_GET['page']);
			$page = strrev($page);
			if(trim($page) == "")
				exit;
	
			$allclicknames = base64_decode($_GET['allelements']);
			if(trim($allclicknames) == "")
				exit;
			
			$allclicknames = urldecode($allclicknames);	
			$allclicknames = json_decode($allclicknames);
	
			if(!is_array($allclicknames))
				exit;	
 	
			$clickname = $_GET['ClickStatSave'];
			if(!in_array($clickname, $allclicknames))
				exit;
	
			self::ClickStatSave($page, $clickname, $allclicknames);
			exit; 
		}		
	} 
	
	//JQUERY AJAX CLICKS
	function ClickStatSave($page, $elemname, $allelements=array()){
		global $addonPathData, $gp_index;
		
		$pagefile = $addonPathData.'/clickstats/'.urlencode($page).'.php';
				
		if(!array_key_exists($page, $gp_index)){
			if(file_exists($pagefile))
				unlink($pagefile);
			return;
		}
		
		//$visitorIP = get_client_ip();
		
		$clickstats = array();		
		if(file_exists($pagefile)){
			
			if(filesize($pagefile) > 3145728)
				return;
			
			include($pagefile);
			foreach($clickstats as $elem => $info){
				if(!in_array($elem, $allelements))
					unset($clickstats[$elem]); 
			}
		}
	
		if(isset($clickstats[$elemname])){
			//get_client_ip()
			//$clickstats[$elemname]['ip']
			$clickstats[$elemname]['count'] = $clickstats[$elemname]['count'] + 1;
		}else{
			//$clickstats[$elemname]['ip'] = array($visitorIP => time() );
			$clickstats[$elemname]['count'] = 1;
		}
				
		gpFiles::SaveArray($pagefile, 'clickstats', $clickstats);		
	}

	// Function to get the client IP address
 	function get_client_ip() {
		$ipaddress = '';
		if (isset($_SERVER['HTTP_CLIENT_IP']))
			$ipaddress = $_SERVER['HTTP_CLIENT_IP'];
		else if(isset($_SERVER['HTTP_X_FORWARDED_FOR']))
			$ipaddress = $_SERVER['HTTP_X_FORWARDED_FOR'];
		else if(isset($_SERVER['HTTP_X_FORWARDED']))
			$ipaddress = $_SERVER['HTTP_X_FORWARDED'];
		else if(isset($_SERVER['HTTP_FORWARDED_FOR']))
			$ipaddress = $_SERVER['HTTP_FORWARDED_FOR'];
		else if(isset($_SERVER['HTTP_FORWARDED']))
			$ipaddress = $_SERVER['HTTP_FORWARDED'];
		else if(isset($_SERVER['REMOTE_ADDR']))
			$ipaddress = $_SERVER['REMOTE_ADDR'];
		else
			$ipaddress = 'UNKNOWN';
		return $ipaddress;
	} 
}


?>
